'use strict';
var util = require('util');
var path = require('path');
var generators = require('yeoman-generator');
var mkdirp = require('mkdirp');

var _o = {
  //Packages list
  _packages : {
    _standart : [
        "gulp",
        "gulp-util",
        "gulp-concat",
        "gulp-connect",
        // "gulp-load-plugins",
        "cssnano",
        "gulp-plumber",
        // "gulp-prettify",
        // "gulp-purifycss",
        "gulp-sass",
        "gulp-sourcemaps",
        // "gulp-uglify",
        "gulp-watch",
        "foundation",
        "jquery"
        //"node-normalize-scs"
      ],
    _testing : [
       "gulp-jasmine"
    ]
  },
  //App structure
  _structure : [
     "/src",
     "/src/fonts",
     "/src/js",
     "/src/styles",
     "/src/img",
     "/public"
    ]
}

var EfigenceGenerator = generators.Base.extend({

  init: function () {

    this.pkg = require('../package.json');

    this.on('end', function () {

    	console.log('end');
      // if (!this.options['skip-install']) {
      //   this.installDependencies();
      // }  
    });
  },
 
  prompting: function () {

    var done = this.async();
    
    this.log('');
    this.log('███████╗███████╗██╗ ██████╗ ███████╗███╗   ██╗ ██████╗███████╗');
    this.log('██╔════╝██╔════╝██║██╔════╝ ██╔════╝████╗  ██║██╔════╝██╔════╝');
    this.log('█████╗  █████╗  ██║██║  ███╗█████╗  ██╔██╗ ██║██║     █████╗  ');
    this.log('██╔══╝  ██╔══╝  ██║██║   ██║██╔══╝  ██║╚██╗██║██║     ██╔══╝  ');
    this.log('███████╗██║     ██║╚██████╔╝███████╗██║ ╚████║╚██████╗███████╗');
    this.log('╚══════╝╚═╝     ╚═╝ ╚═════╝ ╚══════╝╚═╝  ╚═══╝ ╚═════╝╚══════╝');
    this.log('');
    this.log('This is Efigence Simple app generator. Enjoy! ( ͡° ͜ʖ ͡°)');                                                           
    
    var prompts = [
      {
      	  type: "input",
        	name: "appName",
        	message: "App name:"
      },
      {
        type: "list",
        name: "appTests",
        message: "Do you need any tests?",
        choices: ["yes","no"]
      },
      {
        type: "list",
        name: "appDocumenting",
        message: "Do you need any tools for documenting?",
        choices: ["yes","no"]
      },
    ];

    this.prompt(prompts, function (props) {

      this.appName = props.appName;
      this.appTests = props.appTests;
      this.appDocumenting = props.appDocumenting;

      // this.config = {
      //   app: 'app',
      //   dist: 'dist',
      //   tmp:  '.tmp'
      // }

      done();
    }.bind(this));

  },

  _installPackages : function( _packages ){

    var _length = _packages.length;
    
    for( var i = 0; i < _length; i++){
      
       this.npmInstall([_packages[i]], { 
        'saveDev' : true,
        'prefix' : this.appName
      });
    }
  },

  _createStructure : function( _appName, _structure ){
    
    var _length = _structure.length;

    for( var i = 0; i < _length; i++){
      mkdirp(_appName + _structure[i]);  
    }
  },

  _copyTemplate : function( _appName, _src, _options ){

    _options = typeof _options !== 'undefined' ? _options : {};
    
    this.fs.copyTpl(
      this.templatePath( _src ),
      this.destinationPath( _appName + '/' + _src ),
      _options
    );
  },
  
  app: function () {
    
  	if( this.appName === undefined || this.appName === "" || this.appTests === undefined || this.appTests === "" ){
      return;
    }

    mkdirp(this.appName);

    this._installPackages(_o._packages._standart);
    this._createStructure(this.appName, _o._structure);


    this._copyTemplate(this.appName, 'src/index.html', { title: this.appName });
    this._copyTemplate(this.appName, 'src/js/app.js');
    this._copyTemplate(this.appName, 'src/styles/app.scss');
    this._copyTemplate(this.appName, 'src/gulpfile.js');
  }

  runtime: function () {
  },

  projectfiles: function () {
  }
});

module.exports = EfigenceGenerator;
